<?php

class HideSidebar extends Plugin {

	function HideSidebar() {
		$this->plugin_desc = _("Provides a JavaScript link to hide and unhide the sidebar.");
		$this->plugin_version = "0.1.0";
		$this->addOption("default_hide", _("Hide sidebar by default"), 
		                 false, "checkbox");
		$this->addOption("hidden_width", 
		                 _("Width of content area when sidebar is hidden (include units)"),
		                 "96%", "text");
		$this->addOption("link_text_visible", 
		                 _("Text for menubar link when sidebar is visible"), 
		                 _("Hide Sidebar"));
		$this->addOption("link_text_hidden", 
		                 _("Text for menubar link when sidebar is hidden"), 
		                 _("Show Sidebar"));
		$this->addOption("link_style", 
		                 _("CSS style to apply to menubar link"), 
		                 "float: right", "text");
		$this->getConfig();
	}

	function output($ref) {
		global $PAGE;
		$blog = NewBlog();
		if ($blog->isBlog()) $path = $blog->blogid;
		else $path = '';

		$script = '
var default_width = 0;
var hidden_sb_width = "96%";

function save_sb_toggle_state() {
	var date = new Date();
	var state = document.getElementById("sidebar").style.display;
	date.setTime(date.getTime()+(5184000000));
	document.cookie = "sb_hide_state="+state+"; expires="+date.toGMTString()+"; path=/'.$path.'";
}

function get_sb_toggle_state() {
	var cookie_data = document.cookie.split(";");
	var ret = "block";
	var name = "sb_hide_state=";
	for(var i = 0; i < cookie_data.length; i++) {
		var c = cookie_data[i];
		while (c.charAt(0)==" ") {
			c = c.substring(1,c.length);
		}
		if (c.indexOf(name) == 0) {
			ret = c.substring(name.length,c.length);
			break;
		}
	}
	return ret;
}

function sb_toggle(state) {

	var sb = document.getElementById("sidebar").style.display;
	if (state != 0) sb = state;
	if (sb == "none") {
		document.getElementById("sidebar").style.display = "block";
		document.getElementById("pagecontent").style.width = default_width;
		document.getElementById("sb_toggle_link").innerHTML = "'.$this->link_text_visible.'";
	} else {
		document.getElementById("sidebar").style.display = "none";
		document.getElementById("pagecontent").style.width = hidden_sb_width;
		document.getElementById("sb_toggle_link").innerHTML = "'.$this->link_text_hidden.'";
	}
	save_sb_toggle_state();
	return false;
}

window.onload = function (e) { 
	var state = get_sb_toggle_state();
	default_width = document.getElementById("pagecontent").style.width;
	if (state != "block" && state != "none") {
		state = "'.($this->default_hide ? 'none' : 'block').'";
	}
	if (state == "none") sb_toggle("block");
	else sb_toggle("none");
}
';
		$PAGE->addInlineScript($script);
	}

	function menubar_link($ref) {
		echo '<a style="'.$this->link_style.
		     '" id="sb_toggle_link" href="#" onclick="return sb_toggle(0);">'.
			  ($this->default_hide ? 
		      $this->link_text_hidden : 
		      $this->link_text_visible).'</a>';
	}

}

$plug = new HideSidebar();
$plug->registerEventHandler("page", "OnOutput", "output");
$plug->registerEventHandler("menubar", "OnOutput", "menubar_link");

?>
